<?php


/*
Plugin Name: Rewrite HTTPS in Supercache
Plugin URI: 
Description: Rewrite all the local links from https to http in the supercache buffer output
Author: CTLC UBC
Version: 0.1
Author URI: http://ctlt.ubc.ca
*/

/*  Copyright 2008  UBC Office of Learning Technology  - http://olt.ubc.ca
    written for the University of British Columbia
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

add_filter('wpsupercache_buffer','filter_wpsupercache_buffer');

function filter_wpsupercache_buffer($buffer){
	global $wpdb;
	$url = get_bloginfo('url');
	// create the https domain to search for
	
	$protocol = 'http://';
	
	$domains = $wpdb->get_results( "SELECT * FROM {$wpdb->dmtable} WHERE blog_id = '{$wpdb->blogid}'", ARRAY_A );
	// if you have domain mapping enabled 
	if ( is_array( $domains ) && !empty( $domains ) ):
		$orig_url = parse_url( get_original_url( 'siteurl' ) ); 
		$domains[] = array( 'domain' => $orig_url[ 'host' ], 'path' => $orig_url[ 'path' ], 'active' => 0 );
		foreach( $domains as $details ) {
			$urls[] = "{$protocol}{$details[ 'domain' ]}{$details[ 'path' ]}";
			$urls_searchs[] = str_replace('http://','https://',  "{$protocol}{$details[ 'domain' ]}{$details[ 'path' ]}");
		}
		
		$buffer = str_replace($urls_searchs, $urls, $buffer);
		return $buffer."<!-- Rewrite HTTPS in Supercache :: replace these urls  ( ".implode(", ",$urls_searchs)." )  with these urls ( ".implode(", ",$urls)." ) -->";

	else:	
		$url = get_bloginfo('url');
		$url = str_replace( 'https://','http://',$url ); // make sure that the url is http 
		// create the https domain to search for
		$url_search = str_replace( 'http://','https://', $url ); // make sure that the url is http 
		$buffer = str_replace($url_search, $url, $buffer);
		return $buffer."<!-- Rewrite HTTPS in Supercache :: replace this url {$url_search} with this url {$url} -->";

	endif;
		
	
}